#### other公众号双升级机器人和原创

##### 摘要
公众号刚刚收到了原创邀请测试，大家以后可以在文章后面进行留言了。通过Mojo::Weixin可以提供小冰的接口，将原先那个笨笨的图灵替换成第三代微软小冰。

##### 小冰的使用
输入ijq就可以进入和机器人聊天模式。
输入iq退出和机器人的模式

##### Mojo::Weixin
灰灰开发的一个perl模块，比Webqq更具有可玩性。
##### 介绍
通过该项目，你可以完成微信基本的登录、接收和发送消息，在此基础上你可以通过插件的形式实现更多附加功能，比如：

群管理、聊天记录统计、消息报警、智能问答机器人、在群聊中执行 Perl 代码，查询 Perldoc 文档、消息转发、微信和IRC联通等

此项目是Weixin::Client模块的重构，基于Mojolicious框架，具体更多良好特性，比如：

基于Mojo::Base更好的对象模型、基于Mojo::EventEmitter灵活的事件管理机制、

基于Mojo::UserAgent统一的阻塞和非阻塞HTTP请求、基于Mojo::Log轻量级的日志记录框架 等等

推荐你在使用本模块的同时也更多的了解Mojolicious

```perl
use Mojo::Weixin;
my $client = Mojo::Weixin->new(
    ua_debug  => 0,       #是否打印详细的debug信息
    log_level => "info",  #日志打印级别，debug|info|warn|error|fatal
);

#客户端进行登录
$client->login();

#客户端加载ShowMsg插件，用于打印发送和接收的消息到终端
$client->load("ShowMsg");


#ready事件触发时 表示客户端一切准备就绪：已经成功登录、已经加载完个人/好友/群信息等
#你的代码建议尽量写在 ready 事件中
$client->on(ready=>sub{
    my $client = shift;

    #设置接收消息事件的回调函数，在回调函数中对消息以相同内容进行回复
    $client->on(receive_message=>sub{
        my ($client,$msg)=@_;
        $msg->reply($msg->content); #已以相同内容回复接收到的消息
        #你也可以使用$msg->dump() 来打印消息结构
    });

    #你的其他代码写在此处

});

#客户端开始运行
$client->run();

#run相当于执行一个死循环，不会跳出循环之外
#所以run应该总是放在代码最后执行，并且不要在run之后再添加任何自己的代码了

```
地址：
https://metacpan.org/pod/distribution/Mojo-Weixin/lib/Mojo/Weixin.pod
点击原文链接，就可查看该项目。
